// Déclaration des constantes des broches 
const int led_Rouge=9; // Constante pour la broche 9
const int led_Verte=10; // Constante pour la broche 10
const int led_Bleu=11; // Constante pour la broche 11

// fonction pour combiner les couleurs a 2 états 1 ou 0
void ledRVB(int Rouge, int Vert, int Bleu) {
 if (Rouge==1) digitalWrite(led_Rouge,HIGH); // allume rouge si 1
 if (Rouge==0) digitalWrite(led_Rouge,LOW); // éteint rouge si 0
 if (Vert==1) digitalWrite(led_Verte,HIGH); // allume vert si 1
 if (Vert==0) digitalWrite(led_Verte,LOW); // éteint vert si 0
 if (Bleu==1) digitalWrite(led_Bleu,HIGH); // allume bleu si 1
 if (Bleu==0) digitalWrite(led_Bleu,LOW); // éteint bleu si 0
}

// fonction pour la variation progressive des couleurs 
void ledRVBpwm(int pwmRouge, int pwmVert, int pwmBleu) { // reçoit valeur 0-255 par couleur
 analogWrite(led_Rouge, pwmRouge); // varie entre 0 et 255 la led rouge
 analogWrite(led_Verte, pwmVert); // varie entre 0 et 255 la led verte
 analogWrite(led_Bleu, pwmBleu); // varie entre 0 et 255 la led bleu
}

void setup() 
{ 
 pinMode (led_Rouge,OUTPUT); // pin led_Rouge configurée en sortie
 pinMode (led_Verte,OUTPUT); // pin led_Verte configurée en sortie
 pinMode (led_Bleu,OUTPUT); // pin led-Bleu configurée en sortie
}

void loop(){ 

digitalWrite(led_Verte,HIGH); // allume la couleur verte
delay(1000); // pause
digitalWrite(led_Verte,LOW); // éteint la couleur verte
digitalWrite(led_Rouge,HIGH); // allume la couleur rouge
delay(1000); // pause
digitalWrite(led_Rouge,LOW); // éteint la couleur rouge
digitalWrite(led_Bleu,HIGH); // allume la couleur bleu
delay(1000); // pause
digitalWrite(led_Bleu,LOW); // éteint la couleur bleu

ledRVB(1,0,1); // allume Rouge et Bleu => violet
delay(1000); // pause
ledRVB(0,0,0); // éteint toutes les couleurs
ledRVB(1,1,0); // allume Rouge et Vert => jaune
delay(1000); // pause
ledRVB(0,0,0); // éteint toutes les couleurs
ledRVB(0,1,1); // allume Vert et Bleu => bleu clair
delay(1000); // pause
ledRVB(0,0,0); // éteint toutes les couleurs
ledRVB(1,1,1); // allume Rouge Vert et Bleu => blanc
delay(1000); // pause
ledRVB(0,0,0); // éteint toutes les couleurs

// variation de éteint a rouge
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(i,0,0); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de rouge a violet
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(255,0,i); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de violet a bleu 
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(255-i,0,255); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de bleu a turquoise 
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(0,i,255); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de turquoise a vert
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(0,255,255-i); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de vert a jaune
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(i,255,0); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de turquoise a vert
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(255,255,i); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
// variation de vert a eteint
for (int i=0; i<=255; i+=1) { // défile valeur 0 à 255
  ledRVBpwm(255-i,255-i,255-i); // génère impulsion largeur voulue pour la couleur
  delay(10); //pause
}
ledRVB(0,0,0); // éteint toutes les couleurs
delay(1000); 

}
